{% extends 'iBus/layouts/app.html' %}
{% load static %}
{% block css %}

<link rel="stylesheet" href="{% static 'vendor/datatables.net-bs4/css/dataTables.bootstrap4.min.css' %} ">
<link rel="stylesheet" href="{% static 'vendor/datatables.net-buttons-bs4/css/buttons.bootstrap4.min.css' %}">
<link rel="stylesheet" href="{% static 'vendor/datatables.net-select-bs4/css/select.bootstrap4.min.css' %}">

{% endblock %}
{% block content %}

<div class="row">
    <div class="col">
        <div class="card">
            <div class="card-header">
                <div class="row align-items-center">
                    <div class="col-8">
                        <h5 class="h3 mb-0">Estaciones</h5>
                    </div>
                    <div class="col-4 text-right">
                        <button class="btn btn-lg btn-icon btn-default" type="button" data-toggle="modal"
                            data-target="#createModal">
                            <span class="btn-inner--icon"><i class="fas fa-plus"></i></span>
                            <span class="btn-inner--text">Nueva estación</span>
                        </button>
                    </div>
                </div>
            </div>
            <div class="table-responsive py-4">
                <table class="table table-flush" id="dataTable">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>Nombre</th>
                            <th>Latitud</th>
                            <th>Longitud</th>
                            <th>Fecha Creación</th>
                            <th>Última Actualización</th>
                            <th>Acciones</th>

                        </tr>
                    </thead>
                </table>

            </div>
        </div>
    </div>
</div>


<!-- MODALS -->

<div class="modal fade" id="createModal" tabindex="-1" role="dialog" aria-labelledby="modal-default" aria-hidden="true">
    <div class="modal-dialog modal- modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title" id="modal-title-default">Nueva estación</h6>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <form id="form">
                <div class="modal-body">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="create_aNombre">Nombre</label>
                                <input type="text" class="form-control" id="create_aNombre" name="nombre"
                                    placeholder="Nombre">
                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="create_aLatitud">Latitud</label>
                                <input type="text" class="form-control" id="create_aLatitud" name="create_aLatitud"
                                    placeholder="Latitud">
                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="create_aLongitud">Longitud</label>
                                <input type="text" class="form-control" id="create_aLongitud" name="create_aLongitud"
                                    placeholder="Longitud">
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div id="map" style="height: 500px;"></div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-success" onclick="createItem()">Guardar</button>
                    <button type="button" class="btn btn-link  ml-auto" data-dismiss="modal">Cancelar</button>
                </div>
            </form>
        </div>
    </div>
</div>



<div class="modal fade" id="updateModal" tabindex="-1" role="dialog" aria-labelledby="modal-default" aria-hidden="true">
    <div class="modal-dialog modal- modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title" id="modal-title-default">Actualizar estación</h6>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <form id="form">
                <input type="hidden" id="update_id">
                <div class="modal-body">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="update_aNombre">Nombre</label>
                                <input type="text" class="form-control" id="update_aNombre" name="update_aNombre"
                                    placeholder="Nombre">
                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="update_aLatitud">Latitud</label>
                                <input type="text" class="form-control" id="update_aLatitud" name="update_aLatitud"
                                    placeholder="Latitud">
                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label class="form-control-label" for="update_aLongitud">Longitud</label>
                                <input type="text" class="form-control" id="update_aLongitud" name="update_aLongitud"
                                    placeholder="Longitud">
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div id="updateMap" style="height: 500px;"></div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-success" onclick="updateItem()">Guardar</button>
                    <button type="button" class="btn btn-link  ml-auto" data-dismiss="modal">Cancelar</button>
                </div>
            </form>
        </div>
    </div>
</div>


{% endblock %}


{% block script %}

<script src="{% static 'vendor/datatables.net/js/jquery.dataTables.min.js' %} "></script>
<script src="{% static 'vendor/datatables.net-bs4/js/dataTables.bootstrap4.min.js' %} "></script>

<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCvvUs70-PeGPCCNDUN0BtrzNgtHQhdMxQ"></script>

<script>

    $(document).ready(function () {
        $('#dataTable').DataTable({
            'ajax': {
                "type": "POST",
                "dataType": 'json',
                "data": function (d) {
                    d.operation = 'read';
                    d.csrfmiddlewaretoken = '{{ csrf_token }}';
                },
                "dataSrc": function (json) {
                    $.each(json.estaciones, function (i, estacion) {
                        estacion["acciones"] = `
                        <button type="button" class="btn btn-warning btn-icon-only" onclick="selectItem('` + estacion.id + `')"><span class="btn-inner--icon"><i class="fas fa-edit"></i></span></button>
                    <button type="button" class="btn btn-danger btn-icon-only" onclick="deleteItem('`+ estacion.id + `')"><span class="btn-inner--icon"><i class="fas fa-trash"></i></span></button>`
                    });
                    return json.estaciones
                }
            },
            "columns": [
                { "data": "id" },
                { "data": "aNombre" },
                { "data": "aLatitud" },
                { "data": "aLongitud" },
                { "data": "aCreated_at" },
                { "data": "aUpdated_at" },
                { "data": "acciones" }
            ],
            language: {
                paginate: {
                    previous: "<i class='fas fa-angle-left'>",
                    next: "<i class='fas fa-angle-right'>"
                }
            }
        });

    });

    $('#createModal').on('shown.bs.modal', function () {
        var mapSettings = {
            zoom: 15,
            maxZoom: 25,
            disableDefaultUI: true,
            center: { lat: 20.521809, lng: -100.813973 },
            mapTypeId: 'satellite'
        };
        var map = new google.maps.Map(document.getElementById("map"), mapSettings);
        var marker;
        google.maps.event.addListener(map, 'click', function (event) {
            if (marker != null) {
                marker.setMap(null);
            }
            marker = new google.maps.Marker({
                position: event.latLng,
                map: map
            });
            lat = event.latLng.lat();
            lng = event.latLng.lng();
            $("#create_aLatitud").val(lat.toFixed(6));
            $("#create_aLongitud").val(lng.toFixed(6));
        });
    });

    function selectItem(id) {
        $.ajax({
            type: "POST",
            dataType: 'json',
            data: {
                'operation': 'select',
                'id': id,
                'csrfmiddlewaretoken': '{{ csrf_token }}',
            }, success: function (cntx) {
                $("#update_id").val(cntx.id);
                $("#update_aNombre").val(cntx.aNombre);
                $("#update_aLatitud").val(cntx.aLatitud);
                $("#update_aLongitud").val(cntx.aLongitud);
                $('#updateModal').modal('show');
                var mapSettings = {
                    zoom: 20,
                    maxZoom: 25,
                    disableDefaultUI: true,
                    center: { lat: parseFloat(cntx.aLatitud), lng: parseFloat(cntx.aLongitud) },
                    mapTypeId: 'satellite'
                };
                var map = new google.maps.Map(document.getElementById("updateMap"), mapSettings);
                var marker;
                marker = new google.maps.Marker({
                    position: {lat: parseFloat(cntx.aLatitud), lng: parseFloat(cntx.aLongitud) },
                    map: map
                });
                google.maps.event.addListener(map, 'click', function (event) {
                    if (marker != null) {
                        marker.setMap(null);
                    }
                    marker = new google.maps.Marker({
                        position: event.latLng,
                        map: map
                    });
                    lat = event.latLng.lat();
                    lng = event.latLng.lng();
                    $("#update_aLatitud").val(lat.toFixed(6));
                    $("#update_aLongitud").val(lng.toFixed(6));
                });
            }, error: function () {
                Swal.fire(
                    'Error!',
                    'Error al completar la solicitud',
                    'error'
                );
            }
        }
        );
    }

    function createItem() {
        $.ajax({
            type: "POST",
            dataType: 'json',
            data: {
                'operation': 'create',
                'aNombre': $("#create_aNombre").val(),
                'aLatitud': $("#create_aLatitud").val(),
                'aLongitud': $("#create_aLongitud").val(),
                'csrfmiddlewaretoken': '{{ csrf_token }}',
            }, success: function (cntx) {
                if (cntx.status == "200") {
                    $('#createModal').modal('hide');
                    $("#form")[0].reset();
                    $('#dataTable').DataTable().ajax.reload();
                    Swal.fire(
                        'Correcto',
                        'Se ha guardado la estación',
                        'success'
                    )

                } else if (cntx.status == "500") {
                    Swal.fire(
                        'Error!',
                        'Verifique que los campos sean correctos',
                        'error'
                    )
                }

            }, error: function () {
                Swal.fire(
                    'Error!',
                    'Error al completar la solicitud',
                    'error'
                );
            }
        });
    }
    function updateItem() {
        $.ajax({
            type: "POST",
            dataType: 'json',
            data: {
                'operation': 'update',
                'id': $("#update_id").val(),
                'aNombre': $("#update_aNombre").val(),
                'aLatitud': $("#update_aLatitud").val(),
                'aLongitud': $("#update_aLongitud").val(),
                'csrfmiddlewaretoken': '{{ csrf_token }}',
            }, success: function (cntx) {
                if (cntx.status == "200") {
                    $('#updateModal').modal('hide');
                    $('#dataTable').DataTable().ajax.reload();
                    Swal.fire(
                        'Correcto',
                        'Se ha actualizado el vehículo',
                        'success'
                    )
                } else if (cntx.status == "500") {
                    Swal.fire(
                        'Error!',
                        'Ocurrio un error, intentelo nuevamente',
                        'error'
                    )
                }
            }, error: function () {
                Swal.fire(
                    'Error!',
                    'Error al completar la solicitud',
                    'error'
                );
            }
        }
        );
    }
    function deleteItem(id) {
        Swal.fire({
            title: '¿Estas seguro?',
            text: "Esta acción no podrá ser reversible",
            type: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            cancelButtonText: 'Cancelar',
            confirmButtonText: 'Eliminar'
        }).then((result) => {
            if (result.value) {
                $.ajax({
                    type: "POST",
                    dataType: 'json',
                    data: {
                        'operation': 'delete',
                        'id': id,
                        'csrfmiddlewaretoken': '{{ csrf_token }}',
                    }, success: function (cntx) {
                        if (cntx.status == "200") {
                            $('#dataTable').DataTable().ajax.reload();
                            Swal.fire(
                                'Correcto',
                                'Se ha eliminado la estación',
                                'success'
                            )
                        } else if (cntx.status == "500") {
                            Swal.fire(
                                'Error!',
                                'Ocurrio un error, intentelo nuevamente',
                                'error'
                            )
                        }
                    }, error: function () {
                        Swal.fire(
                            'Error!',
                            'Error al completar la solicitud',
                            'error'
                        );
                    }
                });



            }
        })

    }


</script>


{% endblock %}